---
name: Bug report
about: Create a report to help us improve
title: ''
labels: 'bug'
assignees: ''

---

:rotating_light: First, please check:
 - existing issues,
 - Docs https://cpp.objectbox.io/

**Describe the bug**
A clear and concise description in English of what the bug is.

**Basic info (please complete the following information):**
 - ObjectBox version: [e.g. 0.10.0, latest version?]
 - C or C++ version: [e.g. C++11]
 - Reproducibility: [e.g. occurred once only | occasionally without visible pattern | always]
 - OS: [e.g. Ubuntu 20.04]

**To Reproduce**
Steps to reproduce the behavior:
1. Put '...'
2. Make changes to '....'
3. See error

**Expected behavior**
A clear and concise description of what you expected to happen.

**Code**
If applicable, add code to help explain your problem.
 - Include affected entity code.
 - Please remove any unnecessary or confidential parts.
 - At best, link to or attach a project with a failing test.

**Logs, stack traces**
If applicable, add relevant logs, or a stack trace.

**Additional context**
Add any other context about the problem here.
 - Is there anything special about your code?
 - May transactions or multi-threading play a role?
 - Did you find any workarounds to prevent the issue?
